<script setup lang="ts">
import { useReceiptStore } from '@/stores/receipt'
import { computed, onMounted, ref } from 'vue'
import ReceiptPaperHistory from './ReceiptPaperHistory.vue'
import { useMemberStore } from '@/stores/member'
import type { Member } from '@/types/Member'

const receiptStore = useReceiptStore()
const memberStore = useMemberStore()

const formatDate = (dateString: any): string => {
  if (!dateString) return ''

  const options: Intl.DateTimeFormatOptions = {
    year: 'numeric',
    month: 'numeric',
    day: 'numeric',
    hour: 'numeric',
    minute: 'numeric'
  }

  const formattedDate = new Date(dateString).toLocaleString('en-US', options)
  return formattedDate
}

const showReceiptPaper = (receiptId: number) => {
  console.log(receiptId)
  receiptStore.getOrder(receiptId)
}

const search = ref<{ query: string; memberTel: string }>({ query: '', memberTel: '' })

const filteredOrders = computed(() => {
  const query = search.value.query.toLowerCase() // Convert search query to lowercase
  const memberTelQuery = search.value.memberTel.toLowerCase() // Convert member telephone query to lowercase

  return receiptStore.Orders.filter((order) => {
    const orderIdMatch = order.userId.toString().includes(query)
    const memberTelMatch = order.member?.tel.toLowerCase().includes(memberTelQuery)

    return orderIdMatch || memberTelMatch
  })
})

onMounted(async () => {
  await receiptStore.getOrders()
  console.log(receiptStore.Orders)
})
</script>
<template>
  <v-parallax height="auto" overflow-y="hidden">
    <h1><v-icon icon="mdi mdi-book-clock" class="mr-5"></v-icon>Receipt History</h1>
    <v-card>
      <!-- <v-col cols="12" sm="6">
        <v-text-field v-model="search.query" prepend-inner-icon="mdi-magnify" density="compact" label="Search"
          single-line flat hide-details variant="solo-filled"></v-text-field>
      </v-col> -->
      <v-card-text>
        <v-form ref="refForm">
          <v-table fixed-header height="1200px" style="overflow: auto">
            <thead>
              <tr>
                <th class="text-center">ID</th>
                <th class="text-center">Employee</th>
                <th class="text-center">Time</th>
                <th class="text-center">Member Tel</th>
                <th class="text-center">Quantity</th>
                <th class="text-center">Total</th>
                <th class="text-center">paymentType</th>
                <th class="text-center">receipt</th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="item in filteredOrders" :key="item.id">
                <td class="text-center">{{ item.id }}</td>
                <td class="text-center">{{ item.user?.fullName }}</td>
                <td class="text-center">{{ formatDate(item.created) }}</td>
                <td class="text-center">
                  {{ item.member?.tel ? item.member.tel : '-' }}
                </td>
                <td class="text-center">{{ item.qty }}</td>
                <td class="text-center">{{ item.total }}</td>
                <td class="text-center">{{ item.paymentType }}</td>
                <td class="text-center">
                  <v-icon size="small" class="me-2" @click="showReceiptPaper(item.id)">mdi-eye</v-icon>
                </td>
              </tr>
            </tbody>
          </v-table>
        </v-form>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-parallax>
  <ReceiptPaperHistory></ReceiptPaperHistory>
</template>

<style scoped>
* {
  font-family: 'Kanit';
}
</style>
